﻿namespace AP
{
    using System;

    public class Math
    {
        public const double MachineEpsilon = 5E-16;
        public const double MaxRealNumber = 1E+300;
        public const double MinRealNumber = 1E-300;
        public static Random RndObject = new Random((DateTime.Now.Millisecond + (0x3e8 * DateTime.Now.Second)) + (0xea60 * DateTime.Now.Minute));

        public static double AbsComplex(Complex z)
        {
            double num2 = System.Math.Abs(z.x);
            double num3 = System.Math.Abs(z.y);
            double num = (num2 > num3) ? num2 : num3;
            double num4 = (num2 < num3) ? num2 : num3;
            if (num4 == 0.0)
            {
                return num;
            }
            double num5 = num4 / num;
            return (num * System.Math.Sqrt(1.0 + (num5 * num5)));
        }

        public static Complex Conj(Complex z)
        {
            return new Complex(z.x, -z.y);
        }

        public static Complex CSqr(Complex z)
        {
            return new Complex((z.x * z.x) - (z.y * z.y), (2.0 * z.x) * z.y);
        }

        public static int RandomInteger(int N)
        {
            lock (RndObject)
            {
                return RndObject.Next(N);
            }
        }

        public static double RandomReal()
        {
            lock (RndObject)
            {
                return RndObject.NextDouble();
            }
        }

        public static double Sqr(double X)
        {
            return (X * X);
        }
    }
}

