﻿namespace NORMDISTR
{
    using AP;
    using System;

    public class NORMDISTR
    {
        public static double erf(double x)
        {
            double num2 = 0.0;
            double num3 = 0.0;
            double num4 = 0.0;
            double num5 = 0.0;
            num3 = System.Math.Sign(x);
            x = System.Math.Abs(x);
            if (x < 0.5)
            {
                num2 = x * x;
                num4 = 0.0075477280334186317;
                num4 = 0.2888051372075941 + (num2 * num4);
                num4 = 14.33838421917482 + (num2 * num4);
                num4 = 38.0140318123903 + (num2 * num4);
                num4 = 3017.8278853650759 + (num2 * num4);
                num4 = 7404.0714271015149 + (num2 * num4);
                num4 = 80437.363096084024 + (num2 * num4);
                num5 = 0.0;
                num5 = 1.0 + (num2 * num5);
                num5 = 38.01907139519394 + (num2 * num5);
                num5 = 658.07015545924048 + (num2 * num5);
                num5 = 6379.6001732442828 + (num2 * num5);
                num5 = 34216.525792462853 + (num2 * num5);
                num5 = 80437.363096084024 + (num2 * num5);
                return ((((num3 * 1.1283791670955126) * x) * num4) / num5);
            }
            if (x >= 10.0)
            {
                return num3;
            }
            return (num3 * (1.0 - erfc(x)));
        }

        public static double erfc(double x)
        {
            double num2 = 0.0;
            double num3 = 0.0;
            if (x < 0.0)
            {
                return (2.0 - erfc(-x));
            }
            if (x < 0.5)
            {
                return (1.0 - erf(x));
            }
            if (x >= 10.0)
            {
                return 0.0;
            }
            num2 = 0.0;
            num2 = 0.56418778255073976 + (x * num2);
            num2 = 9.6758078829872662 + (x * num2);
            num2 = 77.081617303684283 + (x * num2);
            num2 = 368.51961547100109 + (x * num2);
            num2 = 1143.2620707038861 + (x * num2);
            num2 = 2320.4395902516353 + (x * num2);
            num2 = 2898.0293292167657 + (x * num2);
            num2 = 1826.3348842295113 + (x * num2);
            num3 = 1.0;
            num3 = 17.14980943627608 + (x * num3);
            num3 = 137.12559605006223 + (x * num3);
            num3 = 661.73612071076536 + (x * num3);
            num3 = 2094.3843677895397 + (x * num3);
            num3 = 4429.6128038836823 + (x * num3);
            num3 = 6089.5424232724436 + (x * num3);
            num3 = 4958.82756472114 + (x * num3);
            num3 = 1826.3348842295113 + (x * num3);
            return ((System.Math.Exp(-AP.Math.Sqr(x)) * num2) / num3);
        }

        public static double inverf(double e)
        {
            return (invnormaldistribution(0.5 * (e + 1.0)) / System.Math.Sqrt(2.0));
        }

        public static double invnormaldistribution(double y0)
        {
            double num2 = 0.0;
            double num3 = 0.0;
            double d = 0.0;
            double num5 = 0.0;
            double num6 = 0.0;
            double num7 = 0.0;
            double num8 = 0.0;
            double num9 = 0.0;
            int num10 = 0;
            double num11 = 0.0;
            double num12 = 0.0;
            double num13 = 0.0;
            double num14 = 0.0;
            double num15 = 0.0;
            double num16 = 0.0;
            num2 = 0.1353352832366127;
            num3 = 2.5066282746310007;
            if (y0 <= 0.0)
            {
                return -1E+300;
            }
            if (y0 >= 1.0)
            {
                return 1E+300;
            }
            num10 = 1;
            num5 = y0;
            if (num5 > (1.0 - num2))
            {
                num5 = 1.0 - num5;
                num10 = 0;
            }
            if (num5 > num2)
            {
                num5 -= 0.5;
                num7 = num5 * num5;
                num11 = -59.963350101410789;
                num11 = 98.001075418599967 + (num7 * num11);
                num11 = -56.676285746907027 + (num7 * num11);
                num11 = 13.931260938727968 + (num7 * num11);
                num11 = -1.2391658386738125 + (num7 * num11);
                num12 = 1.0;
                num12 = 1.9544885833814176 + (num7 * num12);
                num12 = 4.6762791289888153 + (num7 * num12);
                num12 = 86.360242139089053 + (num7 * num12);
                num12 = -225.46268785411937 + (num7 * num12);
                num12 = 200.26021238006066 + (num7 * num12);
                num12 = -82.037225616833339 + (num7 * num12);
                num12 = 15.90562251262117 + (num7 * num12);
                num12 = -1.1833162112133 + (num7 * num12);
                d = num5 + (((num5 * num7) * num11) / num12);
                return (d * num3);
            }
            d = System.Math.Sqrt(-(2.0 * System.Math.Log(num5)));
            num8 = d - (System.Math.Log(d) / d);
            num6 = 1.0 / d;
            if (d < 8.0)
            {
                num13 = 4.0554489230596245;
                num13 = 31.525109459989388 + (num6 * num13);
                num13 = 57.162819224642128 + (num6 * num13);
                num13 = 44.080507389320083 + (num6 * num13);
                num13 = 14.684956192885803 + (num6 * num13);
                num13 = 2.1866330685079025 + (num6 * num13);
                num13 = -0.14025607917135449 + (num6 * num13);
                num13 = -0.035042462682784818 + (num6 * num13);
                num13 = -0.00085745678515468545 + (num6 * num13);
                num14 = 1.0;
                num14 = 15.779988325646675 + (num6 * num14);
                num14 = 45.390763512887922 + (num6 * num14);
                num14 = 41.3172038254672 + (num6 * num14);
                num14 = 15.04253856929075 + (num6 * num14);
                num14 = 2.5046494620830941 + (num6 * num14);
                num14 = -0.14218292285478781 + (num6 * num14);
                num14 = -0.038080640769157834 + (num6 * num14);
                num14 = -0.00093325948089545755 + (num6 * num14);
                num9 = (num6 * num13) / num14;
            }
            else
            {
                num15 = 3.2377489177694603;
                num15 = 6.9152288906898418 + (num6 * num15);
                num15 = 3.9388102529247444 + (num6 * num15);
                num15 = 1.3330346081580755 + (num6 * num15);
                num15 = 0.20148538954917911 + (num6 * num15);
                num15 = 0.012371663481782003 + (num6 * num15);
                num15 = 0.00030158155350823543 + (num6 * num15);
                num15 = 2.658069746867375E-06 + (num6 * num15);
                num15 = 6.2397453918498331E-09 + (num6 * num15);
                num16 = 1.0;
                num16 = 6.02427039364742 + (num6 * num16);
                num16 = 3.6798356385616087 + (num6 * num16);
                num16 = 1.3770209948908132 + (num6 * num16);
                num16 = 0.21623699359449666 + (num6 * num16);
                num16 = 0.01342040060885432 + (num6 * num16);
                num16 = 0.00032801446468212774 + (num6 * num16);
                num16 = 2.8924786474538064E-06 + (num6 * num16);
                num16 = 6.7901940800998127E-09 + (num6 * num16);
                num9 = (num6 * num15) / num16;
            }
            d = num8 - num9;
            if (num10 != 0)
            {
                d = -d;
            }
            return d;
        }

        public static double normaldistribution(double x)
        {
            return (0.5 * (erf(x / 1.4142135623730951) + 1.0));
        }
    }
}

