﻿namespace TSLab.Supertrend
{
    using System;
    using System.Collections.Generic;
    using TSLab.Script;
    using TSLab.Script.Handlers;
    using TSLab.Script.Optimization;

    public class Supertrend : IExternalScript, IStreamHandler, IHandler, IOneSourceHandler
    {
        public OptimProperty MultiplierParam = new OptimProperty(9.0, 1.0, 10.0, 0.5);
        public OptimProperty PeriodParam = new OptimProperty(20.0, 2.0, 20.0, 2.0);

        public virtual void Execute(IContext ctx, ISecurity source)
        {
            IList<double> list = new List<double>(source.Bars.Count);
            IList<double> list2 = new List<double>(source.Bars.Count);
            IList<double> list3 = new List<double>(source.Bars.Count);
            IList<double> list4 = new List<double>(source.Bars.Count);
            int num2 = 0;
            double item = 0.0;
            double num5 = 0.0;
            int Period = (int) this.PeriodParam;
            double multiplierParam = (double) this.MultiplierParam;
            IList<double> list5 = ctx.GetData("ATR", new string[] { Period.ToString() }, () => this.GenATR(source, Period));
            int count = source.Bars.Count;
            double num = source.ClosePrices[0];
            for (int i = 0; i < (count - 1); i++)
            {
                double num10 = source.ClosePrices[i];
                num = list5[i];
                double num7 = 0.0;
                double num8 = item;
                double num9 = num5;
                int num3 = num2;
                double num11 = (source.HighPrices[i] + source.LowPrices[i]) / 2.0;
                item = num11 + (multiplierParam * num);
                num5 = num11 - (multiplierParam * num);
                if (num10 > num8)
                {
                    num2 = 1;
                }
                if (num10 < num9)
                {
                    num2 = -1;
                }
                if ((num2 > 0) && (num5 < num9))
                {
                    num5 = num9;
                }
                if ((num2 < 0) && (item > num8))
                {
                    item = num8;
                }
                if ((num2 > 0) && (num3 < 0))
                {
                    num5 = num11 - (multiplierParam * num);
                }
                if ((num2 < 0) && (num3 > 0))
                {
                    item = num11 + (multiplierParam * num);
                }
                if (num2 == 1)
                {
                    num7 = num5;
                }
                if (num2 == -1)
                {
                    num7 = item;
                }
                list.Add(item);
                list2.Add(num5);
                list5.Add(num);
                list3.Add((double) num2);
                list4.Add(num7);
            }
        }

        public IList<double> GenATR(ISecurity source, int Period)
        {
            IList<double> list = new List<double>(source.Bars.Count);
            double num = source.HighPrices[0] - source.LowPrices[0];
            double item = num;
            for (int i = 0; i < source.Bars.Count; i++)
            {
                num = source.HighPrices[i] - source.LowPrices[i];
                if (i > 0)
                {
                    if (source.LowPrices[i] > source.ClosePrices[i - 1])
                    {
                        num += source.LowPrices[i] - source.ClosePrices[i - 1];
                    }
                    if (source.HighPrices[i] < source.ClosePrices[i - 1])
                    {
                        num += source.ClosePrices[i - 1] - source.HighPrices[i];
                    }
                }
                item += (num - item) / ((double) Period);
                list.Add(item);
            }
            return list;
        }
    }
}

